 ;### Rpgmaze-Spectrum-version ### ;### Assembler Source Code v.001 ### ;### Tasm-Assembler-Parameter ###

#define	db .byte
#define	dw .word
#define	equ .equ
#define	end .end

.org $B000			;**Startadresse
	JP	Display
 ;***allgemeine Parameter***
Vram:	dw	$4000		;** vram=16384 (Start Block-disp)
vadr:	dw	$0000		;** temp. Video-Adress
Source:	dw	$0000		;** act.Source-Screen-Adr.
VBlock:	db	$00
Mnr:	db	$06
 ;***Sprite-Parameter***
zeile:	db	$00		;** Sprite-Zeile (1-24)
spalte:	db	$00		;** Sprite-Spalte (1-32)
vold:	dw	$0040		;** old Video-Position of  Sprite
vnew:	dw	$0040		;** new Video-Position of Sprite
v:	dw	$0000		;** temp. Video-Start-Adress
sbadr:	dw	$0000		;** temp. Sprite-Buffer-Address
spadr:	dw	$0000		;** Sprite-Adresse
pause:	dw	$55FF		;** Wait-Wert
fillb:	db	$01		;** Kontroll-Wert 1=ja, 0=nein
 ;#############Start Display the Matrix################
Display:
 ;######read out the matrix-buffer to the disp#########
Loop:	LD HL,(Vram)
	LD (vadr),HL  ;Set vadr.to Start of Vram
	XOR A
	LD (VBlock),A
	LD HL,Matrix
	LD B,$0A	;10
Loopout:     ;-----uere Schleife, 10 Block-Zeilen-----
	PUSH BC
	LD B,$0A	;10
Loopin:      ;+++++Innere Schleife, Print 10 Blocks+++++
	PUSH BC
	PUSH HL
	LD A,(HL) ;Read the act.Blocknr.
	CALL Blockd
	LD HL,(vadr)  ;set HL to next Block
	INC HL
	INC HL
	LD (vadr),HL
	POP HL
	INC HL     ;next Blocknr.
	POP BC
	DJNZ Loopin ;+++++++++++++++++++++++++++++++++++++++++
	PUSH HL
	LD HL,(vadr)
	LD BC,$002C
	ADD HL,BC
	LD (vadr),HL
	POP HL
	POP BC		;** check loop-counter
	DEC B
	LD A,B
	CP $06        ;*****Correkt (vadr)********
	JR NZ,dblock2
	LD DE,$4800   ;***(vadr)=1.Block
	LD (vadr),DE
	LD A,$01
	LD (VBlock),A
	JR Loopout
dblock2:	CP $02
	JR NZ,dend
	LD DE,$5000   ;***(Var)=2.Block
	LD (vadr),DE
	LD A,$02
	LD (VBlock),A
	JR Loopout
dend:	CP $00
	JR NZ,Loopout ;---------------------------------------
	RET
 ;############################ Set the block in the disp ###############################
 db "***Set Block***"
Blockd:
 ;****Correkt the Source-Adr.****
	LD HL,blocks
	CP $00
	JR Z,Block       ;IF Blocknr=0 -> no correctur
                  ;INC A
	LD BC,$0024	;** 16*2 graphic-bytes=32+4 attributes=36
cscr:	ADD HL,BC
	DEC A
	JR NZ,cscr
 ;*********Poke the Block in the Disp*******
Block:	LD (Source),HL   ;Set the corrected source
	LD HL,(vadr)     ;HL=Video-RAM-Start-adr.
	LD DE,(Source)   ;DE=Source-Block-Start-adr.
	LD B,$08         ;8 Punkte (1 Zeile)
Linea:            ;1.Zeile load**********************
	LD A,(DE)        ;Load byte from source
	LD (HL),A        ;to Video-RAM
	INC HL           ;next byte video
	INC DE           ;next byte source
	LD A,(DE)
	LD (HL),A
	INC HL
	INC DE
	PUSH BC          ;Save counter
	LD BC,$00FE      ;Korrektur BC, next Pixelline
	ADD HL,BC        ;HL auf nchste Punktreihe
	POP BC           ;Retourn Pixel-line Counter
	DJNZ Linea       ;8*Pixel pro line******************
	LD HL,(vadr)     ;HL=Source-RAM-Start-adr.
	LD BC,$0020      ;Korrektur Wert -> BC
	ADD HL,BC        ;Korriegiere HL auf nchste Zeile
	LD B,$08         ;8*Punkte fr nchste Zeile
Lineb:            ;2. Zeile load (genau wie 1.Zeile)*************
	LD A,(DE)        ;7E
	LD (HL),A        ;12
	INC HL           ;23
	INC DE           ;13
	LD A,(DE)        ;7E
	LD (HL),A        ;12
	INC HL           ;23
	INC DE           ;13
	PUSH BC          ;Save counter
	LD BC,$00FE      ;Korrektur Wert -> BC
	ADD HL,BC        ;HL auf nchste Punktreihe
	POP BC           ;C1
	DJNZ Lineb       ;10xx
 ;**********Set Attributes***********
	;RET
	LD HL,(vadr)
	LD A,(VBlock)
 ;******Control the Display-Block*******
 ;******Korrektur Addition to Video-RAM******
	CP $00
	JR NZ,CTRL1
	LD BC,$1800
	ADD HL,BC
	JR SETATT
CTRL1:
	CP $01
	JR NZ,CTRL2
	LD BC,$1100
	ADD HL,BC
	JR SETATT
CTRL2:
	CP $02
	JR NZ,SETATT
	LD BC,$0A00
	ADD HL,BC
 ;*****Set it*****
SETATT:
	LD A,(DE)    ;Load Source
	LD (HL),A    ;Poke Source
	INC HL
	INC DE
	LD A,(DE)
	LD (HL),A
	LD BC,$001F ;Korrektur Wert, nchste Zeile
	ADD HL,BC
	LD A,(DE)
	LD (HL),A
	INC HL
	INC DE
	LD A,(DE)
	LD (HL),A
	RET
	db "====="
 ;#################end Display#####################
M1:
Matrix:   ;Matrix-buffer, wird in Disp kopiert
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01
 db $B0,$B1,$B2,$B3,$10,$10,$B4,$B5,$10,$10
 db "====="
 ;**Sprite-Buffer, 1 Block=36 Bytes
sbuffer:
 db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 db $00,$00,$00,$00,$00,$00
 db "====="
blocks:
 db $02,$02,$02,$02,$02,$02,$02,$02,$02,$02
 db $02,$02,$02,$02,$02,$02,$02,$02,$02,$02
 db $02,$02,$02,$02,$02,$02,$02,$02,$02,$02
 db $02,$02,$01,$01,$01,$01
 ;*01 sand
 dw -30200,16800,2050,8712,2113,512,16530,1024,4352,136,1025,8480,-32636,5152,138,16384
 db 48,48,48,48
 ;*02 wasser
 dw -1801,-3653,-14385,8167,31936,8991,-28689,29440,-1991,-13314,14335,-3586,1560,-24605,16376,16358
 db 48,48,48,48
 ;*03 schwarze Tanne
 dw -7415,28947,-18426,23837,-4493,32575,-18162,23853,-4581,30519,-16770,-8883,32287,28479,32003,-233
 db 48,48,48,48
 ;*04 dachfenster
 dw -1,-10909,-1067,-2634,-1098,-2688,-8266,-74,-1152,-2634,-1098,-2688,-1025,21845,-16449,-1
 db 48,48,48,48
 ;*05 dachziegel
 dw -1,-17477,21973,-17477,21973,-17477,-2571,-1,24543,-17477,21973,-17477,21973,-17477,-2571,-1
 db 48,48,48,48
 ;*06 Hausfenster
 dw -1,-7745,16352,-24147,-16403,-24147,16352,-24147,-16403,-24147,16352,-7745,-1,384,-1,-1
 db 48,48,48,48
 ;*07 tuer
 dw -193,864,32095,32447,31421,31421,31421,-1345,6844,-1345,31421,31421,17057,32447,128,-1
 db 48,48,48,48
 ;*08 gras
 dw 0,1568,64,72,65,16641,1,0,4096,2560,2056,4,-32412,2068,4608,4096
 db 48,48,48,48
 ;*09 schwarze Mauer
 dw -1,22485,-16454,32725,-8275,-38,-1,-1,-1,-27685,20383,-17493,20439,-16465,-1,-1
 db 48,48,48,48
 ;*10 bruecke
 dw 1440,1440,1440,1440,-577,1440,1440,1440,-577,1440,1440,1440,-577,1440,1440,1440,1440
 db 48,48,48,48
 ;########################
 ;!*brpgdefg2, define block 11-20
 ;*11 Mauer innen
 dw -1,385,32189,32189,32189,19877,32189,385,-1,384,-577,-593,23970,-577,384,-1
 db 48,48,48,48
 ;*12 Mauerlampe
  dw -1,6,-1292,32748,-16428,24559,-32752,32740,31980,31726,-1040,31983,-16,-14721,-28737,-1
 db 48,48,48,48
 ;*13 Bretterwand
 dw -1,128,-1,-28252,-28252,-28252,-28252,-28252,-28252,-28252,-28252,-28252,-28252,-28252,-1,-1
 db 48,48,48,48
 ;*14 bett oben
 dw -1985,1984,-3425,11178,10922,-5201,6832,4064,-5457,-1089,7920,1984,640,896,640,896
 db 48,48,48,48
 ;*15 Bett unten
 dw 1664,28544,7808,16256,-384,-65,1728,-3169,2720,2976,-1345,-1089,2724,-1,8192,-1
 db 48,48,48,48
 ;*16 zimmerpflanze
 dw 0,30701,-7674,24555,-4001,-13381,24579,-26641,-16225,-4166,4130,-16401,16407,-8237,-15341,-8209
 db 48,48,48,48
 ;*17 vase
 dw 0,-8185,12300,-10213,-6121,10260,-10213,14364,-3017,29744,13360,13360,15896,32268,-1017,-2041
 db 48,48,48,48
 ;*18 schrank oben
 dw -1,3968,-7689,8064,-7802,4088,-3705,-1,384,-577,28087,9634,9634,9634,-577,384
 db 48,48,48,48
 ;*19 schrank unten
 dw -577,17826,21930,17826,-577,384,-577,21930,-10837,21930,21930,-577,384,-1,8192,-1
 db 48,48,48,48
 ;*20 tisch
 dw 2176,-1,576,960,576,960,576,960,-385,960,-385,-2065,5416,-2065,-27608,-5161
 db 48,48,48,48
 ;!*brpgdefg, define blocks 21-30
 ;*21 stuhl
 dw 2,-1,2056,-1,-8185,6120,2192,4080,2320,8184,-5993,8184,-6121,-4105,10388,-10261
 db 48,48,48,48
 ;*22 parkett
 dw -32768,-1,0,-1,0,-1,16,-1,4096,-1,0,-1,1,-1,0,-1
 db 48,48,48,48
 ;*23 bild
 dw -1,-9854,-4731,14727,10629,13706,23438,28043,32661,18363,989,-27730,-24587,-17,-67,-1
 db 48,48,48,48
 ;*24 treppe
 dw -1,-1,-1,21845,-1,-1,-1,-1,-1,-1,-1,21845,-1,-1,-1,-1
 db 48,48,48,48
 ;*25 tisch auf fliese
 dw -1,-65,416,416,416,416,416,416,-97,416,-65,-1353,15030,-1353,31415,1160
 db 48,48,48,48
 ;*26 fliese
 dw -1,128,32447,-321,16062,-321,32447,14006,5268,14006,32447,-321,16062,-321,32447,128
 db 48,48,48,48
 ;*27 teppich links
 dw -17,-73,-34,-73,-17,-69,-43,-69,-17,-73,-34,-73,-17,-69,-43,-69
 db 48,48,48,48
 ;*28 teppich rechts
 dw -2049,-4609,31743,-4609,-2049,-8705,-21505,-8705,-2049,-4609,31743,-4609,-2049,-8705,-21505,-8705
 db 48,48,48,48
 ;*29 wappen unten
 dw 15324,31120,-1648,31123,14748,15801,-16389,15321,14744,31132,-30317,2448,-577,-1,3024,-1
 db 48,48,48,48
 ;*30 wappen oben
 dw -577,-1,3024,2448,-1633,-1633,31132,-29261,32764,15320,14745,-18021,10649,18840,-29252,8191
 db 48,48,48,48
 ;!*brpgdefg4, define blocks 31-40
 ;*31 waitress
 dw -20465,-9285,-4995,-4227,-897,-2115,27668,-4140,-3063,-18,-2044,-18445,20493,-21014,22029,-295
 db 48,48,48,48
 ;*32 shop-woman
 dw -16381,12278,4108,2778,18453,-23372,21546,21674,13356,-9509,-23250,-6321,-18342,21943,-22500,-577
 db 48,48,48,48
 ;*33 hexe
 dw -19433,32184,-7633,13641,-9102,-2782,-19364,-19116,23592,-21673,-19276,32251,-10132,30651,-12241,12243
 db 48,48,48,48
 ;*34 man
 dw -8185,4680,-30316,-22222,22562,11317,-9638,21946,16340,-5637,22877,30319,-20472,-14322,-3503,-32241
 db 48,48,48,48
 ;*35 director
 dw -25603,27643,-18953,31726,-29743,28118,23530,-25639,5544,8812,13724,29598,-19459,8120,8062,-449
 db 48,48,48,48
 ;*36 smallman
 dw -4109,-28530,-25944,-13645,-17731,6809,31934,24186,24314,16028,-3425,-19842,-8517,-24904,-2372,-1105
 db 48,48,48,48
 ;*37 big man
 dw -4105,4232,3765,-20814,-9550,11445,24186,24314,16124,-1633,22941,32383,-29064,-16770,-14735,-1
 db 48,48,48,48
 ;*38 woman
 dw -5345,27384,13541,-27221,24409,-20524,-21820,-20588,26264,-26713,20043,-4132,32475,15346,24306,-4742
 db 48,48,48,48
 ;*39 thin man
 dw -2053,2180,18106,22201,11961,-26966,28317,11197,8186,-2099,-1585,22975,-4163,20412,31678,-617
 db 48,48,48,48
 ;*40 big man
 dw -8185,-2065,-1761,-1089,-17345,-16964,23130,21946,32726,-5637,-9891,30319,-20472,-13330,-4015,-28689
 db 48,48,48,48
 ;!*brpgdefg5, define blocks 41-50
 ;*41-castle-treppe
 dw 1540,32597,-21842,-2049,-1472,-2473,-17430,30719,-17750,30559,-17734,30719,-21766,30687,-1,-1
 db 48,48,48,48
 ;* 42-castle door
 dw 29181,30717,30205,30205,30717,-3617,15865,-8713,24053,-8713,12761,-2049,30205,22013,30717,993
 db 48,48,48,48
 ;* 43-teppich
 dw -21606,-21654,21869,21917,-1,-49,-193,-49,-193,-49,-193,-49,-193,-49,-193,-1
 db 48,48,48,48
 ;* 44-floor
 dw -1,128,-16715,-32579,-1407,-30051,-1354,150,-321,145,32693,145,32703,129,-67,128
 db 48,48,48,48
 ;* 45 kerker unten
 dw 10923,-1,128,21929,-5481,7596,-7021,31663,28123,28123,28347,28347,10921,-321,128,-1
 db 48,48,48,48
 ;* 46 kerker oben
 dw -1,-18707,9417,-1,128,21973,-21845,-12295,-20346,-9515,28075,-21798,28667,-12155,15022,-10859
 db 48,48,48,48
 ;* 47-inn
 dw -1,896,256,-23244,-23244,-23244,-23244,-23244,-19146,-17097,-21195,-23244,-23244,256,896,-1
 db 48,48,48,48
 ;* 48-cafe
 dw -1,896,-14033,9552,-26329,17710,-10961,-30425,6496,13744,26008,-30393,13744,-14001,896,-1
 db 48,48,48,48
 ;* 49-city
 dw 63,-32662,16597,-24438,-3665,8584,-1911,-21334,22189,-23686,-7417,10760,-22006,10760,-3065,256
 db 48,48,48,48
 ;* 50-mauerloch
 dw -1,-21525,-41,-2049,-33,-1,-1,-1,-1,-1,-2065,-5129,-21,-21510,-10283,-1
 db 48,48,48,48
  end
